#include <ZumoMotors.h>  //ZUMO 
#include <EEPROM.h>

#define left_sharp_pin A3
#define forward_sharp_pin A4
#define right_sharp_pin A0
#define BASE_SPEED 150
#define MAX_SPEED 250
#define MIN_SPEED 50
#define turn 370
#define turnl 410
#define turnturn 710
int left_distance;
int right_distance;
int forward_distance;
int back_distance;
int start_back_dist; //       
float Kp = 1;
byte Kd = 70;
float Kk = 0.00022;
int error = 0;
int lasterror = 0;
byte wall_mode = 0;//0 -  , 1 - , 2 - , 3 - 
short old_wall_mode = -1;
#define wallexist 200 //       
#define  half_cell  95 //  -      
#define  step_time 780 //    30 
long stop_step; //  
int r_direction = 0;
bool backway=false;
byte step_count=0;
byte shortstepscount;//    
bool mode = false;//false -    , true -   
bool item=false;//  
// 
float minvals[4];
float maxvals[4];
int grays[4];
int rawvals[4];
int sensors[4];
int Line;
int error_line = 0;
int lastError = 0;
float Kpline = 2.5;
float Kdline = 10.0;
#define LINE_SPEED  150

//   
typedef struct
{
  bool left;
  bool right;
  bool forw;
  bool back;
//  byte x;
//  byte y;
  bool vizited;
} TCell; //Declare and define struct TMyStruct

typedef struct
{
  byte x;
  byte y;
} TPoint;

TPoint startPoint;//set on start
TPoint currentPoint;//set after every step
TPoint finishPoint; //set on finish color
TCell lab[10][22];//big labirint zise of x2
TCell normallab[5][11];//normal labirint
TPoint shortpath[55];//list of points on short path
int matrix[5][11];

#define line1_mode 1
#define lab1_mode 2
#define invers1_mode 3
#define kegel_mode 4
#define invers2_mode 5
#define lab2_mode 6
#define line2_mode 7
#define calibr 8
byte line_mode = 0; // , 1-  , -1-   , 0 -  

byte Cur_Mode  = 0;

ZumoMotors motors;

void setup() {
  Serial.begin(9600);
  pinMode(left_sharp_pin, INPUT); //  
  pinMode(forward_sharp_pin, INPUT);
  pinMode(right_sharp_pin, INPUT);
  //  
  pinMode(A7, INPUT); 
  pinMode(A6, INPUT); 
  pinMode(A2, INPUT); 
  pinMode(A1, INPUT); 
   
  delay(1000);
  get_distance();
  mode = forward_distance < 100;
  delay(3000);
  Serial.println("start");
  motors.flipLeftMotor(true);
  motors.flipRightMotor(true);
  //startinit();
  Calibrate();
  delay(3000);
  Cur_Mode = invers1_mode;
}

void loop() {
  
switch(Cur_Mode)  
{
 case calibr: GetLine();
  Serial.print(sensors[0]);
  Serial.print(" | ");
  Serial.print(sensors[1]);
  Serial.print(" | ");
  Serial.print(sensors[2]);
  Serial.print(" | ");
  Serial.print(sensors[3]);
  Serial.print(" ||| ");
  Serial.println(sensors[1] - sensors[2]);
  
  break;
 case line1_mode: //       

   go_line(); //
   get_distance(); 
   if(!item && forward_distance<250) // 
   {
    motors.setSpeeds(0,0);
    delay(50);
    get_distance();
    if (forward_distance<150) //   -   
    {
      while (forward_distance<200)
       { motors.setSpeeds(0,0);
        get_distance();
       }
      long t=millis();
      while(millis()<t+800)//   ,    
       go_line();
    }
    motors.setSpeeds(0,0);
    delay(50);
    obezd();// 
    item=true;
    }
 break;

 case invers1_mode:  //   
  go_invers();
 break;
 
}
//if (mode)
//{
//  r_direction=2;
//  readshortpath();
// // delay(20000);
//  ShortBack();
// }//mode=1
// else
//{
// where_go();
// delay(300);
// if(step_count>23)
// {
//  //backway=true;
// // turn_round();
//  finishPoint.x = currentPoint.x;
//  finishPoint.y = currentPoint.y;
//   getnormalLab();
//   getMatrix();
//   FillShortPath();
//  writeshortpath();  
//  delay(2000);
//  ShortBack();
//  while(true)
//  {
//    motors.setSpeeds(0,0); 
//    }
//  }
//}//mode=0

}

void go_line ()
{
  GetLine();
  error_line = sensors[1] - sensors[2];
int speedDifference = Kpline * error_line + Kdline * (error_line - lastError);
lastError = error_line;
//Serial.println(speedDifference);
int m1Speed = LINE_SPEED + speedDifference;
int m2Speed = LINE_SPEED - speedDifference;

if (m1Speed < 0)
    m1Speed = 0;
  if (m2Speed < 0)
    m2Speed = 0;
  if (m1Speed > LINE_SPEED)
    m1Speed = LINE_SPEED;
  if (m2Speed > LINE_SPEED)
    m2Speed = LINE_SPEED;
    
   motors.setSpeeds(m2Speed, m1Speed);
  }

void go_invers()
{
  GetLine();
  if (sensors[0] < 50 && sensors[3] < 50)
   line_mode = 1;
  if (sensors[0] > 50 && sensors[3] >50)
   line_mode = -1;


//   
if (line_mode == 1 && sensors[0] > 50 && sensors[3] < 50)   
{
  while (sensors[0] > 50 && sensors[3] < 50)
  {
    motors.setSpeeds(0, 140);
    GetLine();
  }  
}

 if (line_mode == 1 && sensors[0] < 50 && sensors[3] > 50)   
 {
   while (sensors[0] < 50 && sensors[3] > 50)
   {
     motors.setSpeeds(140, 0);
     GetLine();
   }  
 }
  if (line_mode == -1 && sensors[0] < 70 && sensors[3] > 50)     
  {
    while (sensors[0] < 70 && sensors[3] > 50)
    {
      motors.setSpeeds(0, 140);
      GetLine();
    }   
  }
 
   if (line_mode == -1 && sensors[0] > 50 && sensors[3] < 70)   
   {
     while (sensors[0] > 50 && sensors[3] < 70)
     {
       motors.setSpeeds(140, 0);
       GetLine();
     }  
   }

   //     
//if (sensors[0] < 50 && sensors[1] < 50 && sensors[2] < 50 && sensors[3] > 50)
//   { 
//    line_mode = 1;
//     while (sensors[3] > 50)
//     {
//       motors.setSpeeds(140, 0);
//       GetLine();
//      }
//   }
//if (sensors[0] > 50 && sensors[1] < 50 && sensors[2] < 50 && sensors[3] < 50)
//   { 
//    line_mode = 1;
//     while (sensors[0] > 50)
//     {
//       motors.setSpeeds(0, 140);
//       GetLine();
//      }
//   }  
   
if (line_mode==1)
 error_line = (sensors[1] - sensors[2]);// * line_mode;
 else
  error_line = (sensors[2] - sensors[1]);
//if (line_mode ==-1)
// error_line = error_line * 0,5;

//int diff = sensors[0] - sensors[3];//    
//if (abs(diff) > 20)
// {
//   error_line = error_line +  diff * line_mode *-1; 
// }
 
int speedDifference = Kpline * error_line + Kdline * (error_line - lastError);
lastError = error_line;
//Serial.println(speedDifference);
int m1Speed = LINE_SPEED + speedDifference;
int m2Speed = LINE_SPEED - speedDifference;

if (m1Speed < 0)
    m1Speed = 0;
  if (m2Speed < 0)
    m2Speed = 0;
  if (m1Speed > LINE_SPEED)
    m1Speed = LINE_SPEED;
  if (m2Speed > LINE_SPEED)
    m2Speed = LINE_SPEED;
    
   motors.setSpeeds(m2Speed, m1Speed);
  }

  
void show_sensors()
{
 Serial.print(left_distance);
 Serial.print(" | ");
 Serial.print(forward_distance);
 Serial.print(" | ");
 Serial.print(right_distance);
 Serial.print(" | ");
 Serial.print(back_distance);
 Serial.println("");
}

//   3 
void get_distance()
{
  int sharp=analogRead(left_sharp_pin);
  left_distance = min(20760/(sharp-11), 300); 
  if (left_distance < 0) left_distance = 300;   
  sharp=analogRead(forward_sharp_pin);
  forward_distance = min(20760/(sharp-11), 300); 
  if (forward_distance < 0) forward_distance = 300;
  sharp=analogRead(right_sharp_pin);
  right_distance = min(20760/(sharp-11), 300) - 10;//+10 ..       1     
  if (right_distance < 0 || right_distance >300) right_distance = 300;   
    
 }
void obezd()
{
  turn_rightl();
  motors.setSpeeds(140,140); 
  delay(600);
  
  turn_leftl();
  motors.setSpeeds(140,140); 
  long st = millis(); 
  GetLine();
  while (millis() < st + 1800 && (sensors[1] < 60 && sensors[2] <60))
  {
    GetLine();
   }
  motors.setSpeeds(0,0);
  delay(200);
  if (sensors[1] > 60 && sensors[2] >60)
  {
   motors.setSpeeds(-140,-140);
   delay(300); 
  } 
  motors.setSpeeds(0,0);
  delay(200);
  
  turn_leftl();
  motors.setSpeeds(140,140);
  GetLine(); 
  while (sensors[1] < 60 && sensors[2] <60)
  {
     GetLine();
  }
  delay(150);
  motors.setSpeeds(0,0); 
  delay(200); 
  turn_rightl();
  }
  
//  
 void set_pid()
 {
   int speedDifference = 0;
    get_distance();//    
    getwallmode();//   wall_mode
    switch (wall_mode)
    {
     case 3:     
       error = left_distance - right_distance;
       speedDifference = Kp * error + Kd * (error - lasterror)+ Kk*error*error*error;      
       break;
       
     case 2:    
       error = (right_distance - half_cell)*-2;
       speedDifference = Kp * error + Kd * (error - lasterror)+ Kk*error*error*error;       
       break;
      
     case 1:     
       error = (left_distance - half_cell)*2;
       speedDifference = Kp * error + Kd * (error - lasterror)+ Kk*error*error*error;
       break;
      
     case 0:      
       speedDifference = 0;
       break;
      
    }//end of switch (wall_mode)
    
    lasterror = error;
    int RightSpeed = BASE_SPEED + speedDifference;
    int LeftSpeed = BASE_SPEED - speedDifference;
    
    RightSpeed = max(RightSpeed, MIN_SPEED);
    RightSpeed = min(RightSpeed, MAX_SPEED);
    LeftSpeed = max(LeftSpeed, MIN_SPEED);
    LeftSpeed = min(LeftSpeed, MAX_SPEED);
    
    motors.setSpeeds(LeftSpeed, RightSpeed); 
 }

// ,  go_ .. step  
 void go_step()
 {
   old_wall_mode = -1;
   stop_step = millis() + step_time; //     
   get_distance();
   start_back_dist = back_distance;
   while (millis() < stop_step && forward_distance>95)
   {
     set_pid();
     delay(5);
    }
    motors.setSpeeds(0, 0);
    delay(50);
    
    if(forward_distance<200) //      
    {
      if (forward_distance>105)
      { 
        forw_go();
      }     
    }
    else //     ,    
    {
//      if (start_back_dist < 200)
//       back_go(310);
//       else
//        if (start_back_dist < 500)
//         back_go(720);
     }
     
    motors.setSpeeds(0, 0);
    delay(100);
  if (!backway)
  {
    getPoint();
    setcell(currentPoint.x, currentPoint.y);
  }
  step_count++;
 }

//   wall_mode: 0 -  , 1 - , 2 - , 3 - 
 void getwallmode()
 {
      old_wall_mode = wall_mode;//   ,    -    error  lasterror
      byte new_wall_mode = 0;
      if(left_distance < wallexist && right_distance < wallexist) new_wall_mode = 3;// 
      if(right_distance < wallexist && left_distance > wallexist) new_wall_mode =  2;// 
      if(right_distance > wallexist && left_distance < wallexist) new_wall_mode =  1;// 
      if(right_distance > wallexist && left_distance > wallexist) new_wall_mode =  0;// 
      
      if (old_wall_mode == -1) old_wall_mode = new_wall_mode;//       
      if (new_wall_mode != old_wall_mode) //  ,    ,     
      {
        motors.setSpeeds(BASE_SPEED, BASE_SPEED);
       delay(100);  
       if(left_distance < wallexist && right_distance < wallexist) new_wall_mode = 3;// 
       if(right_distance < wallexist && left_distance > wallexist) new_wall_mode =  2;// 
       if(right_distance > wallexist && left_distance < wallexist) new_wall_mode =  1;// 
       if(right_distance > wallexist && left_distance > wallexist) new_wall_mode =  0;// 
      }

       wall_mode = new_wall_mode;
        
      if (wall_mode!=old_wall_mode)//   wall_mode  "" last_error 
      {
       switch (wall_mode)
       {
        case 3:  lasterror = left_distance-right_distance;
        case 2: lasterror = right_distance-half_cell;
        case 1: lasterror = left_distance-half_cell; 
       }
      }
 }
void turn_rightl()
{
   motors.setSpeeds(150,-150); 
  delay(turnl); 
   motors.setSpeeds(0,0); 
  delay(200); 
  
  }
 void turn_leftl()
{
   motors.setSpeeds(-150,150); 
  delay(turnl); 
     motors.setSpeeds(0,0); 
  delay(200); 
  }
void turn_right()
{
  byte r_dist[100];//    
  byte crdist = 0;//   r_dist
  byte n_dist[100];//      
  byte c_dist = 250;
  int add_dist = 0;
  byte add = 0;
  int c_port = left_sharp_pin;

  long StartRotate = millis();
  while (millis() < StartRotate + turn)
   {
     motors.setSpeeds(BASE_SPEED, -BASE_SPEED);
     int sharp=analogRead(c_port);
     c_dist = min(20760/(sharp-11), 250); 
     if (c_dist < 0) c_dist = 250;   
     add_dist = add_dist + c_dist;
     add++;
     if (add == 25) //  25  -       
      {
        r_dist[crdist] = add_dist / 25;
        add_dist = 0;
        add = 0;
        crdist++;
      }
     if (crdist == 100) //      100 - ,    
       crdist = 0;    
   }
   motors.setSpeeds(0, 0); //   

   //  
  r_direction = r_direction +1;
  if (r_direction==4) r_direction = 0;
  
//     200,       ""
  if (r_dist[crdist - 1] < 200)
  {
  byte c_index = 0;
//      0  99
   for (int i = crdist-1; i > 0; --i)
   {
     n_dist[c_index] = r_dist[i];
     c_index ++;
    }
  for (int i = 99; i > crdist+1; --i)
   {
     n_dist[c_index] = r_dist[i];
     c_index ++;
    }
//  delay(20000);  
// for (int i = 0; i < 100; i++)
//  Serial.println(n_dist[i]);
 
 //     ,      40 ,    5  -   
c_dist = n_dist[0];
byte m_dist = c_dist;
byte m_index = 0;

for (int i = 1; i < 40; i++)
 {
 if (m_dist > n_dist[i])
  {
   m_dist = n_dist[i];
   m_index = i;
  }
 }
   
  if (c_dist > m_dist + 5)
  {
    StartRotate = millis();
    long ms = StartRotate + m_index*4 + 10;
    
    //  
     while (millis() < ms)
     {
       motors.setSpeeds(-BASE_SPEED, BASE_SPEED);
      }
     motors.setSpeeds(0, 0);
     delay(200);
  }   
  }//     200   ""
}


void turn_left()
{
  byte r_dist[100];//    
  byte crdist = 0;//   r_dist
  byte n_dist[100];//      
  byte c_dist = 250;
  int add_dist = 0;
  byte add = 0;
  int c_port = right_sharp_pin;

   
  long StartRotate = millis();
  while (millis() < StartRotate + turn)
   {
     motors.setSpeeds(-BASE_SPEED, BASE_SPEED);
     int sharp=analogRead(c_port);
     c_dist = min(20760/(sharp-11), 250); 
     if (c_dist < 0) c_dist = 250;   
     add_dist = add_dist + c_dist;
     add++;
     if (add == 25) //  25  -       
      {
        r_dist[crdist] = add_dist / 25;
        add_dist = 0;
        add = 0;
        crdist++;
      }
     if (crdist == 100) //      100 - ,    
       crdist = 0;    
   }
   motors.setSpeeds(0, 0); //   

   //  
 r_direction = r_direction -1;
 if (r_direction==-1) r_direction = 3;
  
//     200,       ""
  if (r_dist[crdist - 1] < 200)
  {
  byte c_index = 0;
//      0  99
   for (int i = crdist-1; i > 0; --i)
   {
     n_dist[c_index] = r_dist[i];
     c_index ++;
    }
  for (int i = 99; i > crdist+1; --i)
   {
     n_dist[c_index] = r_dist[i];
     c_index ++;
    }

 
 //     ,      40 ,    5  -   
c_dist = n_dist[0];
byte m_dist = c_dist;
byte m_index = 0;

for (int i = 1; i < 40; i++)
 {
 if (m_dist > n_dist[i])
  {
   m_dist = n_dist[i];
   m_index = i;
  }
 }
   
  if (c_dist > m_dist + 5)
  {
    //  
     StartRotate = millis();
     long ms = StartRotate + m_index*4 + 10;
     
     //  
     while (millis() < ms)
     {
       motors.setSpeeds(BASE_SPEED, -BASE_SPEED);
      }
     motors.setSpeeds(0, 0);
     delay(200);
  }   
  }//     200   ""
}

void turn_round()
{
    byte r_dist[100];//    
  byte crdist = 0;//   r_dist
  byte n_dist[100];//      
  byte c_dist = 250;
  byte c_distr = 250;
  byte c_distl = 250;
  int add_dist = 0;
  byte add = 0;
  int direct = 1;
  int c_port = right_sharp_pin;
  if (right_distance > left_distance)
   {
    direct = -1;
    c_port = left_sharp_pin;
   }
   
  long StartRotate = millis();
  while (millis() < StartRotate + turnturn)
  {
    motors.setSpeeds(-BASE_SPEED * direct, BASE_SPEED * direct);
    int sharp=analogRead(c_port);
     c_dist = min(20760/(sharp-11), 250); 
     if (c_dist < 0) c_dist = 250;   
     add_dist = add_dist + c_dist;
     add++;
     if (add == 25) //  25  -       
      {
        r_dist[crdist] = add_dist / 25;
        add_dist = 0;
        add = 0;
        crdist++;
      }
     if (crdist == 100) //      100 - ,    
       crdist = 0;    
   }
  
    r_direction = r_direction + 2;
    if (r_direction==4) r_direction = 0;
    if (r_direction==5) r_direction = 1;
    // r_direction= r_direction%4;
 motors.setSpeeds(0, 0);
 //      ""
  byte c_index = 0;
//      0  99
   for (int i = crdist-1; i > 0; --i)
   {
     n_dist[c_index] = r_dist[i];
     c_index ++;
    }
  for (int i = 99; i > crdist+1; --i)
   {
     n_dist[c_index] = r_dist[i];
     c_index ++;
    }
    
 //     ,      60 ,    5  -   
c_dist = n_dist[0];
byte m_dist = c_dist;
byte m_index = 0;

for (int i = 1; i < 40; i++)
 {
 if (m_dist > n_dist[i])
  {
   m_dist = n_dist[i];
   m_index = i;
  }
 }
   
  if (c_dist > m_dist + 5)
  {
    //  
     StartRotate = millis();
     long ms = StartRotate + m_index*4 + 10;
     
     //  
     while (millis() < ms)
     {
       motors.setSpeeds(BASE_SPEED * direct, -BASE_SPEED * direct);
      }
     motors.setSpeeds(0, 0);
     delay(200);
  }   
 
}




//void turn_left()
//{
//  long StartRotate = millis();
//  while (millis() < StartRotate + turn)
//   motors.setSpeeds(-BASE_SPEED, BASE_SPEED);
//   
// motors.setSpeeds(0, 0);
// r_direction = r_direction -1;
// if (r_direction==-1) r_direction = 3;
// // r_direction= r_direction%4;
// Serial.println("turn_left");
// Serial.print("direction: ");
// Serial.println(r_direction);
//}


//void turn_round()
//{
//  long StartRotate = millis();
//  while (millis() < StartRotate + turnturn)
//   motors.setSpeeds(BASE_SPEED, -BASE_SPEED);
//    r_direction = r_direction + 2;
//    if (r_direction==4) r_direction = 0;
//    if (r_direction==5) r_direction = 1;
//    // r_direction= r_direction%4;
// motors.setSpeeds(0, 0);
// Serial.println("turn_round");
// Serial.print("direction: ");
// Serial.println(r_direction);
//}

void where_go()//   
{
  get_distance();

if(right_distance>200)
{
  turn_right();
  delay(300);
   go_step();
 }
 else
 {
  if(forward_distance>200)
  {
    go_step();
  }
   else
   {
   if(left_distance>200)
    {
      turn_left();
      delay(300);
       go_step();
     }
    else
    {
     turn_round();
     delay(300);
      go_step();
     
    }
   }
 }
  delay(300);
}

void forw_go()//   
{
  while(forward_distance>95)
  {
    motors.setSpeeds(120, 120);
    get_distance();
  }
    motors.setSpeeds(0, 0);
    delay(100);
}

void back_go(int dist)//   
{
  while(back_distance<dist)
  {
    motors.setSpeeds(120, 120);
    get_distance();
  }
    motors.setSpeeds(0, 0);
    delay(100);
}

//   
void setcell(int x, int y)
{
  lab[x][y].vizited = true;
  switch (r_direction)
  {
  case 0:
    lab[x][y].left = left_distance > wallexist;
    lab[x][y].right = right_distance > wallexist;
    lab[x][y].forw = forward_distance > wallexist;
    lab[x][y].back = true;
//    lab[x][y].x = x;
//    lab[x][y].y = y;
    break;

  case 1: //if turn right
    lab[x][y].right = forward_distance > wallexist;
    lab[x][y].forw = left_distance > wallexist;
    lab[x][y].back = right_distance > wallexist;
    lab[x][y].left = true;
//    lab[x][y].x = x;
//    lab[x][y].y = y;
    break;
  case 2: //if turn back
    lab[x][y].back = forward_distance > wallexist;
    lab[x][y].left = right_distance > wallexist;
    lab[x][y].right = left_distance > wallexist;
    lab[x][y].forw = true;
//    lab[x][y].x = x;
//    lab[x][y].y = y;
    break;

  case 3: //if turn left
    lab[x][y].left = forward_distance > wallexist;
    lab[x][y].forw = right_distance > wallexist;
    lab[x][y].back = left_distance > wallexist;
    lab[x][y].right = true;
//    lab[x][y].x = x;
//    lab[x][y].y = y;

    break;
  }
}

//        (r_direction)
void getPoint()
{
  switch (r_direction)
  {
  case 0:
    currentPoint.y = currentPoint.y + 1;
    break;

  case 1:
    currentPoint.x = currentPoint.x + 1;
    break;

  case 2:
    currentPoint.y = currentPoint.y - 1;
    break;

  case 3:
    currentPoint.x = currentPoint.x - 1;
    break;

  }
}

void getnormalLab() //        511 (normallab)
{
  //get x0
  byte x0 = 255;//    (       )

  for (byte x_0 = 0; x_0 < 5; x_0++)
    for (byte y = 0; y < 22; y ++)
    if (lab[x_0][y].vizited == true && x0==255)
    x0 = x_0;
  if (x0==255) x0 = 5;
  
//  Serial.print("x0: ");
//  Serial.println(x0);
  
  //get y0
  byte y0 = 255;//   Y (       )
  for (byte y_0 = 0; y_0 < 11; y_0++)
    for (byte x = 0; x < 10; x ++)
    if (lab[x][y_0].vizited == true && y0==255)
    y0 = y_0;
   if (y0==255) y0 = 11;
//  Serial.print("y0: ");
//  Serial.println(y0);
  
  //      ()
  startPoint.x = startPoint.x - x0;
  startPoint.y = startPoint.y - y0;
  //      ()
  finishPoint.x = finishPoint.x - x0;
  finishPoint.y = finishPoint.y - y0;


  Serial.print("finishPoint.x: ");
  Serial.println(finishPoint.x);
  Serial.print("finishPoint.y: ");
  Serial.println(finishPoint.y);
  
  //   "" 
  for (byte x=0; x<5; x++)
    for (byte y=0; y<11; y++)
  {
    normallab[x][y].left = false;
    normallab[x][y].right = false;
    normallab[x][y].forw = false;
    normallab[x][y].back = false;
//    normallab[x][y].x = x;
//    normallab[x][y].y = y;
    normallab[x][y].vizited = false;
  }
  //     x0  y0 -      
  byte normalx = 0;
  byte normaly = 0;
  for (short x = x0; x < x0+5; x++)
  {
    normaly = 0;
    for (byte y = y0; y < y0+11; y++)
    {
      normallab[normalx][normaly].left = lab[x][y].left;
      normallab[normalx][normaly].right = lab[x][y].right;
      normallab[normalx][normaly].forw = lab[x][y].forw;
      normallab[normalx][normaly].back = lab[x][y].back;
//      normallab[normalx][normaly].x = normalx;
//      normallab[normalx][normaly].y = normaly;
      normallab[normalx][normaly].vizited = lab[x][y].vizited;
      normaly++;
    }
    normalx++;
  }
}

//  
void getMatrix()
{
  //    99 
  for (byte x=0; x<5; x++)
    for (byte y=0; y<11; y++)
      matrix[x][y] = 99;
 
  matrix[startPoint.x][startPoint.y] = 0;//      0 

  byte StepNumber = 0; //    -     
  //
  //every time we check all cells on equal value and StepNumber, if value=StepNumber we check nearly cells on availability and if true - set stepnumber on it
  int x=0;
  int y=0;
  bool isfinish = false;
  //   ,            (StepNumber),  ,   ,        ,    , ,        
  //   ,  ,            ,   99 -            
  while (StepNumber < 99 && !isfinish)
  {
    for (x=0; x<5; x++)
      for (y=0; y<11; y++)
    {
      if (matrix[x][y] == StepNumber)
      {
//        Serial.print("x: ");
//        Serial.print(x);
//        Serial.print("y: ");
//        Serial.print(y);
//        Serial.print("matrix xy: ");
//        Serial.println(matrix[x][y]);
//        Serial.print("left: ");
//        Serial.print(normallab[x][y].left);
//        Serial.print("right: ");
//        Serial.print(normallab[x][y].right);
//        Serial.print("forw: ");
//        Serial.print(normallab[x][y].forw);
//        Serial.print("back: ");
//        Serial.print(normallab[x][y].back);
        
        
        if (normallab[x][y].left == true) //   ,   -       .. x-1 > -1
          if (x-1>-1 && x-1 < 5)
          if (matrix[x-1][y] > StepNumber+1) //     ,    -       
        {
          matrix[x-1][y] = StepNumber +1;
          if (finishPoint.x==x-1 && finishPoint.y==y) //      -  
          {
            isfinish = true;
          }
        }
        if (normallab[x][y].right == true) //   ,   -       .. x+1 < 5
          if (x+1>-1 && x+1 < 5)
          if (matrix[x+1][y] > StepNumber+1)//     ,    -       
        {
          matrix[x+1][y] = StepNumber +1;
          if (finishPoint.x==x+1 && finishPoint.y==y) //      -  
          {
            isfinish = true;
          }
        }
        if (normallab[x][y].forw == true)  //   ,   -       .. y+1 < 11
       {
          if (y+1>-1 && y+1 < 11)
      {
          if (matrix[x][y+1] > StepNumber+1) //     ,    -       
          {
           matrix[x][y+1] = StepNumber +1;
          if (finishPoint.x==x && finishPoint.y==y+1) //      -  
          {
            isfinish = true;
          }
        }
      }
      }
        if (normallab[x][y].back == true) //   ,   -       .. y-1 > -1
          if (y-1>-1 && y-1 < 11)
          if (matrix[x][y-1] > StepNumber+1)//     ,    -       
        {
          matrix[x][y-1] = StepNumber +1;
          if (finishPoint.x==x && finishPoint.y==y-1) //      -  
          {
            isfinish = true;
          }
        }

      }
    }
    StepNumber++;
  }

//  // 
//    for (byte x=0; x<5; x++)
//    {
//      for (byte y=0; y<11; y++)
//       {
//        Serial.print(matrix[x][y]);
//        Serial.print(" | ");
//       }
//       Serial.println();
//    }
}

void startinit()
{
  startPoint.x = 5;
  startPoint.y = 11;
  currentPoint.x = 5;
  currentPoint.y = 11;

  for (byte x=0; x<10; x++)
    for (byte y=0; y<22; y++)
  {
    lab[x][y].left = false;
    lab[x][y].right = false;
    lab[x][y].forw = false;
    lab[x][y].back = false;
//    lab[x][y].x = x;
//    lab[x][y].y = y;
    lab[x][y].vizited = false;
  }
  get_distance();
  setcell(currentPoint.x, currentPoint.y);
}

void FillShortPath()
{
  //    
  for (int i=0; i<50; i++)
  {
    shortpath[i].x = 255;
    shortpath[i].y = 255;
  }
 
  currentPoint.x = finishPoint.x;
  currentPoint.y = finishPoint.y;
 
  int Step = matrix[finishPoint.x][finishPoint.y];
  shortstepscount = Step;
  shortpath[Step].x = currentPoint.x;
  shortpath[Step].y = currentPoint.y;
  bool stepready = false;
// Serial.println("before while");
  while (Step > -1)
  {
    stepready = false;
    if (currentPoint.x > 0)
      if (matrix[currentPoint.x-1][currentPoint.y] == Step - 1)
      if (normallab[currentPoint.x][currentPoint.y].left)
    {
      shortpath[Step-1].x = currentPoint.x-1;
      shortpath[Step-1].y = currentPoint.y;
      currentPoint.x = currentPoint.x-1;
      stepready=true;
    }
    if (currentPoint.x < 4 && !stepready)
      if (matrix[currentPoint.x+1][currentPoint.y] == Step - 1)
      if (normallab[currentPoint.x][currentPoint.y].right)
    {
      shortpath[Step-1].x = currentPoint.x+1;
      shortpath[Step-1].y = currentPoint.y;
      currentPoint.x = currentPoint.x+1;
      stepready=true;
    }
    if (currentPoint.y > 0 && !stepready)
      if (matrix[currentPoint.x][currentPoint.y-1] == Step - 1)
      if (normallab[currentPoint.x][currentPoint.y].back)
    {
      shortpath[Step-1].x = currentPoint.x;
      shortpath[Step-1].y = currentPoint.y-1;
      currentPoint.y = currentPoint.y-1;
      stepready=true;
    }
    if (currentPoint.y < 10 && !stepready)
      if (matrix[currentPoint.x][currentPoint.y+1] == Step - 1)
      if (normallab[currentPoint.x][currentPoint.y].forw)
    {
      shortpath[Step-1].x = currentPoint.x;
      shortpath[Step-1].y = currentPoint.y+1;
      currentPoint.y = currentPoint.y+1;
      stepready=true;
    }
    Step = Step - 1;
 //   Serial.println(Step);
  }
}

byte getDirection(TPoint CPoint, TPoint NextPoint)
{
  if (CPoint.x > NextPoint.x) return 3;
  if (CPoint.x < NextPoint.x) return 1;
  if (CPoint.y < NextPoint.y) return 0;
  if (CPoint.y > NextPoint.y) return 2;  
}

//        
void ShortBack()
{
  backway = true;//on back way don't setcell
 
  for (int i = shortstepscount; i>0; --i) //in last iterration we calc direction to last cell (i-1)
  {
    short newDirection = getDirection(shortpath[i], shortpath[i-1]);

     switch (newDirection)
    {
    case 0:
      if (r_direction==1)
        turn_left();
      else
        if (r_direction==2)
        turn_round();
      else
        if (r_direction==3)
        turn_right();
      break;

    case 1:
      if (r_direction==0)
        turn_right();
      else
        if (r_direction==2)
        turn_left();
      else
        if (r_direction==3)
        turn_round();
      break;

    case 2:
      if (r_direction==0)
        turn_round();
      else
        if (r_direction==1)
        turn_right();
      else
        if (r_direction==3)
        turn_left();
      break;

    case 3:
      if (r_direction==0)
        turn_left();
      else
        if (r_direction==1)
        turn_round();
      else
        if (r_direction==2)
        turn_right();
      break;
    }
    delay(300);
    go_step();
    delay(300);
  }
 
}

void showlab()
{
  byte val;
 for (int x = 0; x < 10; x++)
   {
   for (int y = 0; y < 22; y++)
   {
     val = 0;
     if (lab[x][y].left) val = val +1;
     if (lab[x][y].forw) val = val +2;
     if (lab[x][y].right) val = val +4;
     if (lab[x][y].back) val = val +8;
     Serial.print(val);
     Serial.print(" | ");
     
    }
    Serial.println();
   }
 }

 void shownlab()
{
  byte val;
 for (int x = 0; x < 5; x++)
   {
   for (int y = 0; y < 11; y++)
   {
     val = 0;
     if (normallab[x][y].left) val = val +1;
     if (normallab[x][y].forw) val = val +2;
     if (normallab[x][y].right) val = val +4;
     if (normallab[x][y].back) val = val +8;
     Serial.print(val);
     Serial.print(" | ");
     
    }
    Serial.println();
   }
 }

 void ShowMatrix()
 {
  // 
    for (byte x=0; x<5; x++)
    {
      for (byte y=0; y<11; y++)
       {
        Serial.print(matrix[x][y]);
        Serial.print(" | ");
       }
       Serial.println();
    }
  }
void writeshortpath()
{byte i=1;
 byte k=0;
  EEPROM.write(0,shortstepscount);
  while(k<(shortstepscount+1)*2+1)
   {
    EEPROM.write(i,shortpath[k].x);
     i++;
    EEPROM.write(i,shortpath[k].y);
    i++;
    k++;
    }
  }
  
  void showshortpath()
{
  byte i=1;
 byte k=0;
  shortstepscount=EEPROM.read(0);
  Serial.println(shortstepscount);
  while(i<(shortstepscount+1)*2+1)
  {
    Serial.print(EEPROM.read(i));
    i++;
    Serial.print("||");
    Serial.println(EEPROM.read(i));
    i++;
    k++;
    }
  }

void readshortpath()
{
  byte i=1;
 byte k=0;
  shortstepscount=EEPROM.read(0);
  Serial.println(shortstepscount);
  while(i<(shortstepscount+1)*2+1)
  {
    shortpath[k].x=EEPROM.read(i);
    Serial.print(EEPROM.read(i));
    i++;
    Serial.print("||");
    shortpath[k].y=EEPROM.read(i);
    Serial.println(EEPROM.read(i));
    i++;
    k++;
    }
  }

void readshortpath2()
{
  byte i=(shortstepscount+1)*2+1;
 byte k=0;
  shortstepscount=EEPROM.read(0);
  Serial.println(shortstepscount);
  while(i>0)
  {
    shortpath[k].x=EEPROM.read(i);
    Serial.print(EEPROM.read(i));
    i--;
    Serial.print("||");
    shortpath[k].y=EEPROM.read(i);
    Serial.println(EEPROM.read(i));
    i--;
    k++;
    }
  }

  //   

  void Calibrate()
{
 long _start = millis();
 motors.setSpeeds(150, -150);

// 
for (int i = 0; i < 4; i++)
   {
    minvals[i] = 700;
    maxvals[i] = 0;
   }
 while (millis() - _start < 5000)
 {
    GetRawSensors();
   for (int i = 0; i < 4; i++)
   {
    minvals[i] = min(minvals[i], rawvals[i]);
    maxvals[i] = max(maxvals[i], rawvals[i]);
   }
 }  
 motors.setSpeeds(0, 0);
   for (int i = 0; i < 4; i++)
   {
    grays[i] = (minvals[i] + maxvals[i])/2;
   } 
   
 }

void GetRawSensors()
{
 rawvals[0] = analogRead(A7);
 rawvals[1] = analogRead(A6);
 rawvals[2] = analogRead(A2);
 rawvals[3] = analogRead(A1);
}

void GetSensors()
{
  GetRawSensors();
  for (int i = 0; i < 4; i++)
   {
    float s = 100 * (max((rawvals[i]-minvals[i]),0)/(maxvals[i]-minvals[i]));
    sensors[i] = s;
   }
}

void GetLine()

{
   GetSensors();
   int S3 = sensors[3];
   int S4 = sensors[4];
   int S2 = sensors[2];  
   int S1 = sensors[1];
  //     1,  2,  3,  4
  Line = (S4 - S3);  
  
}